###################################################
### chunk number 1: 
###################################################
#line 39 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
library(tileHMM)
data(simChIP)



###################################################
### chunk number 2: 
###################################################
#line 61 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
h3k27.data <- as.matrix(simChIP[ , 7:14])



###################################################
### chunk number 3: 
###################################################
#line 68 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"

h3k27.data <- log(h3k27.data, 2)
h3k27.norm <- preprocessCore::normalize.quantiles(h3k27.data)



###################################################
### chunk number 4: 
###################################################
#line 79 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
par(mfrow = c(2, 2))
smoothScatter(h3k27.norm[ , 1], h3k27.norm[ , 5], xlab = "H3 sample 1", 
    ylab = "H3K27me3 sample 1")
smoothScatter(h3k27.norm[ , 2], h3k27.norm[ , 6], xlab = "H3 sample 2", 
    ylab = "H3K27me3 sample 2")
smoothScatter(h3k27.norm[ , 3], h3k27.norm[ , 7], xlab = "H3 sample 3", 
    ylab = "H3K27me3 sample 3")
smoothScatter(h3k27.norm[ , 4], h3k27.norm[ , 8], xlab = "H3 sample 4", 
    ylab = "H3K27me3 sample 4")



###################################################
### chunk number 5: 
###################################################
#line 104 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
h3k27.stat <- shrinkt.st(h3k27.norm, c(rep(2, 4), rep(1, 4)), verbose = 0)



###################################################
### chunk number 6: 
###################################################
#line 114 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
def.par <- par(no.readonly = TRUE)

h <- hist(h3k27.stat, breaks = 100, plot=FALSE)
layout(matrix(c(1,2), 1, 2), width=c(3,1))
par(mar=c(5,4,2,1))
smoothScatter(simChIP[,2], h3k27.stat, xlab = 'genomic position', 
    ylab='probe statistic',nrpoints=500) 
par(mar=c(5,0,2,1))
barplot(h$counts, horiz=TRUE, axes=FALSE)

par(def.par)


###################################################
### chunk number 7: 
###################################################
#line 147 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
hmm.init <- hmm.setup(h3k27.stat, 
    state = c("non-enriched","enriched"), pos.state = 2)



###################################################
### chunk number 8: 
###################################################
#line 156 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
show(hmm.init)
plot(hmm.init)



###################################################
### chunk number 9: 
###################################################
#line 163 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
plot(hmm.init)


###################################################
### chunk number 10: 
###################################################
#line 181 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
max.gap <- 999
h3k27.gap <- diff(simChIP[['position']]) > max.gap
gap.idx <- which(h3k27.gap)



###################################################
### chunk number 11: 
###################################################
#line 192 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
start <- c(1, gap.idx + 1)
end <- c(gap.idx, length(h3k27.stat))
h3k27.lst <- mapply(function(s, e, data) data[s:e], start, end, 
    MoreArgs = list(h3k27.stat)) 



###################################################
### chunk number 12: 
###################################################
#line 205 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
hmm.opt <- viterbiEM(hmm.init, h3k27.lst, df = 9)



###################################################
### chunk number 13: 
###################################################
#line 246 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
print(hmm.opt)
plot(hmm.opt)



###################################################
### chunk number 14: 
###################################################
#line 253 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
plot(hmm.opt)


###################################################
### chunk number 15: 
###################################################
#line 265 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
post <- lapply(h3k27.lst, posterior, hmm.opt)
state.seq <- lapply(post, apply, 2, which.max)
state.seq <- states(hmm.opt)[c(state.seq, recursive=TRUE)]



###################################################
### chunk number 16: densOverlay eval=FALSE
###################################################
## #line 276 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
## ratio <- sum(state.seq == 'enriched') / length(state.seq)
## 
## hist(h3k27.stat, breaks=100, probability=TRUE, main='', 
##     xlab = 'probe statistic')
##     
## plot(hmm.opt@emission$enriched, new.plot = FALSE, 
##     lty = 1, lwd = 2, col = 4, weight = ratio)
## 
## plot(hmm.opt@emission$'non-enriched', new.plot = FALSE, 
##     lty = 2, lwd = 2, col = 2, weight = 1 - ratio)
## 
## legend('topright', legend = c('enriched', 'non-enriched'), 
##     lty = 1:2, lwd = 2, col = c(4,2))
## 


###################################################
### chunk number 17: 
###################################################
#line 299 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
#line 276 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw#from line#299#"
ratio <- sum(state.seq == 'enriched') / length(state.seq)

hist(h3k27.stat, breaks=100, probability=TRUE, main='', 
    xlab = 'probe statistic')
    
plot(hmm.opt@emission$enriched, new.plot = FALSE, 
    lty = 1, lwd = 2, col = 4, weight = ratio)

plot(hmm.opt@emission$'non-enriched', new.plot = FALSE, 
    lty = 2, lwd = 2, col = 2, weight = 1 - ratio)

legend('topright', legend = c('enriched', 'non-enriched'), 
    lty = 1:2, lwd = 2, col = c(4,2))

#line 300 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"


###################################################
### chunk number 18: 
###################################################
#line 313 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
regions.idx <- region.position(state.seq, region = 'enriched')



###################################################
### chunk number 19: 
###################################################
#line 325 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
regions.pos <- matrix(simChIP[regions.idx, 2], 
    nrow = 2, ncol = dim(regions.idx)[2])



###################################################
### chunk number 20: 
###################################################
#line 349 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
post.enriched <- lapply(post,"[",2,)
post.enriched <- exp(c(post.enriched, recursive = TRUE))
region.score <- apply(regions.idx, 2, 
    function(reg, post) mean(post[reg[1]:reg[2]]), post.enriched)



###################################################
### chunk number 21: 
###################################################
#line 358 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
region.len <- apply(regions.pos, 2, diff)



###################################################
### chunk number 22: 
###################################################
#line 370 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
plot(region.len, region.score, xlab = 'region length',
    ylab = 'score', pch = '')
plot.idx <- region.len < 400 & region.score < 0.8
points(region.len[plot.idx], region.score[plot.idx], col = 2, pch = 4)
points(region.len[!plot.idx], region.score[!plot.idx], col = 4)



###################################################
### chunk number 23: 
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
regions.clean <- remove.short(regions.idx, post.enriched, 
    simChIP[ , 1:2], min.length = 400, min.score = 0.8)



###################################################
### chunk number 24: 
###################################################
#line 400 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
gff <- reg2gff(regions.clean, post.enriched, simChIP[ , 1:2])


###################################################
### chunk number 25:  eval=FALSE
###################################################
## #line 403 "d:/Rcompile/CRANpkg/local/2.12/tileHMM/inst/doc/tileHMM.Rnw"
## gff <- reg2gff(regions.clean, post.enriched, simChIP[ , 1:2],
##     file = 'simRegions.gff')


